#ifndef CAR_H
#define CAR_H

#include "GL/glut.h"
#include "ViewPoint.h"
#include "Surface.h"
#include "Road.h"

class Car {
   public:
      Car();
//      Car(string model);

      virtual void aim();
      virtual void render();
      virtual void animate(double dt);
      void applyHeadlights();
      void setPath(vector<Vector3D> path);

      void toggleAutoPilot();
      void releaseWheel();
      void releaseThrottle();

      void steerLeft();
      void steerRight();
      void accelerate();
      void decelerate();

   private:
      void fixAngle();
      void changeSpeed(double change);
      void followRoad(double dt);

      Surface surface;
      Vector3D position;
      double speed;

      bool autoPilot;
      double facing;
      double width, height, depth;
      enum {STRAIGHT = 0, LEFT = 1, RIGHT = 2} steer;
      enum {CONSTANT = 0, ACCELERATE = 1, DECELERATE = 2} throttle;

      vector<Vector3D> controlPoints;
      int controlSection;
      double controlT;
};

#endif
