#ifndef DSSHAPE_H
#define DSSHAPE_H

#include <string>
#include <sstream>
#include "Surface.h"
#include "MalformedShapeException.h"
#include "Vector3D.h"

using std::string;
using std::stringstream;

class DSShape {
   public:
      static DSShape* create(string s) throw(MalformedShapeException);
      static double square(double x) { return x*x; }
      static double abs(double x) {
         if (x < 0) {
            x = -x;
         }
         return x;
      }

      virtual void render() = 0;
      string getDSType() { return this->DSType; }
      static Vector3D calculateNormal(Vector3D a, Vector3D b);
      static void drawNormal(Vector3D start, Vector3D normal);
      double min(double a, double b);

   private:
      static DSShape* stringToShape(string DSType, string spec) throw(MalformedShapeException);
      static unsigned int lightNumber;

   protected:
      Surface surface;
      double extra;
      string DSType;
};

#endif
