#ifndef DSSHAPELIST_H
#define DSSHAPELIST_H

#include <cassert>
#include <iostream>

#include <string>
#include <vector>
#include <fstream>
#include "DSShape.h"
#include "MalformedShapeException.h"

#include "ViewPoint.h"
#include "Light.h"
#include "Road.h"

using std::string;
using std::vector;
using std::ifstream;

class DSShapeList {

   public:
      DSShapeList();
      DSShapeList(string filename);
      void addShape(DSShape* shape) { shapes.push_back(shape); }
      void render();
      vector<Light*> getLights();
      vector<ViewPoint*> getViewPoints();
      vector<Road*> getRoads();
      void read(string filename) throw(MalformedShapeException);
      void free();

   private:
      void sortShapes();

      vector<DSShape*> shapes;

};

#endif
