#ifndef LIGHT_H
#define LIGHT_H

#include <sstream>
#include "GL/glut.h"
#include "DSShape.h"
#include "Vector3D.h"

using std::istringstream;

#define ALPHA 1.0
#define MAX_LIGHTS 4

class Light: public DSShape {

   public:
      explicit Light();
      Light(string spec, unsigned int lightIndex);
      virtual void render();
      void enable();
      void disable();
      void toggle();
      void apply();

   private:
      unsigned int lightIndex;
      double x, z;
      bool enabled;
      int positional;
      Surface ambient;

};

#endif

