#ifndef ROAD_H
#define ROAD_H

#include "DSPolygon.h"

#define BEZIER_POINTS 3
#define BEZIER_SEGMENTS 40
#define ROAD_HEIGHT 0.1

class Road: public DSPolygon {
   public:
      Road(string spec);
      virtual void render();
      vector<Vector3D> getControlPoints();

      static Vector3D getBezierPoint(Vector3D p0, Vector3D p1, Vector3D p2, Vector3D p3, double t);
      static Vector3D getBezierTangent(Vector3D p0, Vector3D p1, Vector3D p2, Vector3D p3, double t);

};

#endif
