#include "Sign.h"

#define RADIUS 0.1
#define POST_HEIGHT 6.0

Sign::Sign(string spec): DSPolygon(spec) {}

/**
 * render a sign
 * (flat polygon, above a thin stick)
 */
void Sign::render() {
   surface.apply();

   Vector3D p0(vertices.at(0));
   Vector3D p1(vertices.at(1));

   double width = p1.getX() - p0.getX();
   double depth = p1.getZ() - p0.getZ();

   Vector3D top(width, extra, depth);
   //Vector3D normal(calculateNormal(p1-p0, p0+top));
   Vector3D normal(calculateNormal(Vector3D(width, 0, depth), Vector3D(0, 1, 0)));
   normal.normalise();

   double texCoord = surface.getScale();

   glBegin(GL_QUADS);
   glNormal3d(normal.getX(), normal.getY(), normal.getZ());
   glTexCoord2d(0,texCoord);
   glVertex3d(p0.getX(),       POST_HEIGHT,     p0.getZ());
   glTexCoord2d(texCoord, texCoord);
   glVertex3d(p0.getX()+width, POST_HEIGHT,     p0.getZ()+depth);
   glTexCoord2d(texCoord, 0);
   glVertex3d(p0.getX()+width, extra, p0.getZ()+depth);
   glTexCoord2d(0,0);
   glVertex3d(p0.getX(),       extra, p0.getZ());
   glEnd();
   glDisable(GL_TEXTURE_2D);

   drawNormal(p0+(Vector3D(width, (extra-POST_HEIGHT), depth)*0.5), normal);

   glPushMatrix();
   glColor3ub(255, 255, 255);
   glTranslated(p0.getX()+width/2.0, POST_HEIGHT/2.0, p0.getZ()+depth/2.0);
   glScaled(RADIUS, POST_HEIGHT, RADIUS);
   glutSolidCube(1);
   glPopMatrix();

}


