#ifndef SURFACE_H
#define SURFACE_H

#include "GL/glut.h"
#include "Texture.h"

class Surface {
   public:
      Surface();
      Surface(int fillR, int fillG, int fillB, string textureName, GLfloat textureScale);

      void apply();
      GLfloat getScale();
      void setScale(GLfloat scale);
      void setTexture(Texture* t);
      void setColour(int r, int g, int b);

      bool hasTexture() { return (texture != NULL); }
      int getRed() { return fillR; }
      int getGreen() { return fillG; }
      int getBlue() { return fillB; }

   private:
      int fillR, fillG, fillB;
      Texture* texture;
      GLfloat textureScale;

};

#endif
