#include "Tree.h"

#define NUM_SLICES 12
#define NUM_STACKS 12

Tree::Tree(string spec): DSPolygon(spec) {}

/**
 * render a 3D tree
 * (cylindrical stalk + icecream scoop/sphere in 1:5 radii ratio)
 */
void Tree::render() {
   surface.apply();

   Vector3D centre(vertices.at(0));
   Vector3D control(vertices.at(1));

   double radius = (control - centre).length();

   glPushMatrix();
   GLUquadricObj* quad = gluNewQuadric();
   gluQuadricDrawStyle(quad, GLU_FILL);
   gluQuadricNormals(quad, GLU_SMOOTH);
   glTranslated(centre.getX(), 0, centre.getZ());
   glRotatef(90, -1, 0, 0);
   gluCylinder(quad, radius/5.0, radius/5.0, extra, NUM_SLICES, NUM_STACKS);
   gluDeleteQuadric(quad);
   glPopMatrix();

   glPushMatrix();
   glTranslated(centre.getX(), extra, centre.getZ());
   glutSolidSphere(radius, NUM_SLICES, NUM_STACKS);
   glPopMatrix();

}


