#ifndef VIEWPOINT_H
#define VIEWPOINT_H

#include <sstream>
#include <vector>

#include "GL/glut.h"
#include "DSShape.h"
#include "Vector3D.h"

#define VIEWPOINT_HEIGHT 10

using std::vector;
using std::istringstream;

class ViewPoint: public DSShape {

   public:
      ViewPoint();
      ViewPoint(double lx, double lz, double fx, double fz);
      ViewPoint(string spec);
      virtual void aim();
      virtual void transform(Vector3D displacement);
      virtual void render() {}
      void transition(ViewPoint& target);
      void interpolate(double dt);

   private:
      Vector3D location;
      Vector3D target;

      vector<Vector3D> controlPoints;
      double controlT;

};

#endif

