#include "DSView.h"

//callback functions, have to be static/non-class-members.
//this delegation was the best I could come up with ...
void DSKeyReleaseHandler(unsigned char key, int x, int y);
void DSKeyPressHandler(unsigned char key, int x, int y);
void DSMouseHandler(int button, int state, int x, int y);
void DSMouseMotionHandler(int x, int y);
void DSResizeHandler(int width, int height);
void DSRenderHandler();

//STATIC GLOBAL!?! Oh no! Arguably OK, since it makes DSView private to this file.
//Necessary evil since glut callbacks don't work on C++ classes, so we
//need this wrapper to let us get the benefit of both worlds.
static DSView dsview;

int main(int argc, char** argv) {
   glutInit(&argc, argv);
   dsview.initGL(argc, argv);

   glutDisplayFunc(&DSRenderHandler);
   glutIdleFunc(&DSRenderHandler);
   glutKeyboardUpFunc(&DSKeyReleaseHandler);
   glutKeyboardFunc(&DSKeyPressHandler);
   glutReshapeFunc(&DSResizeHandler);
   glutMouseFunc(&DSMouseHandler);
   glutMotionFunc(&DSMouseMotionHandler);

   dsview.run(false);
   return 0;
}

void DSKeyReleaseHandler(unsigned char key, int x, int y) {
   dsview.keyRelease(key, x, y);
}

void DSKeyPressHandler(unsigned char key, int x, int y) {
   dsview.keyPress(key, x, y);
}

void DSMouseHandler(int button, int state, int x, int y) {
   dsview.mousePress(button, state, x, y);
}

void DSMouseMotionHandler(int x, int y) {
   dsview.mouseMotion(x, y);
}

void DSResizeHandler(int width, int height) {
   dsview.resize(width, height);
}

void DSRenderHandler() {
   dsview.render();
}

